Index: /trunk/src/org/apollo/io/IconRepository.java
===================================================================
--- /trunk/src/org/apollo/io/IconRepository.java	(revision 1101)
+++ /trunk/src/org/apollo/io/IconRepository.java	(revision 1102)
@@ -1,18 +1,16 @@
 package org.apollo.io;
 
-import java.awt.Color;
-import java.awt.Graphics2D;
-import java.awt.Image;
-import java.awt.image.BufferedImage;
 import java.net.URL;
 import java.util.HashMap;
 
-import javax.swing.Icon;
-import javax.swing.ImageIcon;
-
 import org.apollo.gui.Strokes;
+import org.expeditee.core.Colour;
+import org.expeditee.core.Image;
+import org.expeditee.core.Line;
+import org.expeditee.gio.EcosystemManager;
+import org.expeditee.gio.GraphicsManager;
 
 /**
- * An icon provider. Only loads icons once and when they are requested (somple proxy approach).
+ * An icon provider. Only loads icons once and when they are requested (simple proxy approach).
  * 
  * @author Brook Novak
@@ -21,27 +19,33 @@
 public final class IconRepository {
 	
-	private static HashMap<String, Icon> _loadedIcons = new HashMap<String, Icon>();
-	private static Icon missingIcon = null;
+	private static HashMap<String, Image> _loadedIcons = new HashMap<String, Image>();
+	
+	private static Image missingIcon = null;
 
-	private IconRepository() {}
+	private IconRepository()
+	{
+	}
 	
-	private static Icon getMissingIcon() {
-		
+	private static Image getMissingIcon()
+	{
 		if (missingIcon == null) {
 			
-			Image image = new BufferedImage(16, 16, BufferedImage.TYPE_INT_RGB);
-			Graphics2D g = (Graphics2D)image.getGraphics();
+			Image image = EcosystemManager.getImageManager().createImage(16, 16, false);
 			
-			g.setStroke(Strokes.SOLID_2);
+			GraphicsManager g = EcosystemManager.getGraphicsManager();
 			
-			// White square with X
-			g.setColor(Color.WHITE);
-			g.fillRect(0, 0, 16, 16);
+			g.pushDrawingSurface(image);
 			
-			g.setColor(Color.RED);
-			g.drawLine(0, 0, 16, 16);
-			g.drawLine(0, 16, 16, 0);
+			g.clear(Colour.WHITE);
+
+			Line l1 = new Line(0, 0, 16, 16);
+			Line l2 = new Line(0, 16, 16, 0);
+
+			g.drawLine(l1, Colour.RED, Strokes.SOLID_2);
+			g.drawLine(l2, Colour.RED, Strokes.SOLID_2);
 			
-			missingIcon = new ImageIcon(image);
+			g.popDrawingSurface();
+			
+			missingIcon = image;
 		}
 			
@@ -54,23 +58,20 @@
 	 * @return
 	 */
-	public static Icon getIcon(String name) {
-		Icon icon = _loadedIcons.get(name);
+	public static Image getIcon(String name)
+	{
+		Image icon = _loadedIcons.get(name);
 		
 		if (icon == null) {
 			try {
-			        URL url;
+				URL url;
 				ClassLoader classLoader = Thread.currentThread().getContextClassLoader();
 				if (classLoader!=null) {
 				    // Applet friendly
 				    url = classLoader.getResource("org/apollo/assets/icons/" + name);
-				}
-				else {
+				} else {
 				    url = ClassLoader.getSystemResource("org/apollo/assets/icons/" + name);
 				}
 
-				if (url != null) {
-					icon = new ImageIcon(url);
-				}
-				
+				if (url != null) icon = Image.getImage(url);
 			} catch (Exception e) {
 				e.printStackTrace();
Index: /trunk/src/org/apollo/io/SampledAudioFileImporter.java
===================================================================
--- /trunk/src/org/apollo/io/SampledAudioFileImporter.java	(revision 1101)
+++ /trunk/src/org/apollo/io/SampledAudioFileImporter.java	(revision 1102)
@@ -1,10 +1,10 @@
 package org.apollo.io;
 
-import java.awt.Point;
 import java.io.File;
 import java.io.IOException;
 
 import org.apollo.widgets.SampledTrack;
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.core.Point;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.importer.FileImporter;
 import org.expeditee.items.Item;
@@ -18,17 +18,16 @@
 public class SampledAudioFileImporter implements FileImporter {
 
-	public Item importFile(File f, Point location) throws IOException {
-
-		if (location == null || !AudioIO.canImportFile(f) ||
-				DisplayIO.getCurrentFrame() == null) return null;
+	public Item importFile(File f, Point location) throws IOException
+	{
+		if (location == null || !AudioIO.canImportFile(f) || DisplayController.getCurrentFrame() == null) return null;
 		
 		SampledTrack trackWidget = SampledTrack.createFromFile(
 				f,
-				DisplayIO.getCurrentFrame(), 
+				DisplayController.getCurrentFrame(), 
 				location.x, 
 				location.y);
 		
 		// Add the sampled track widget to the current frame
-		DisplayIO.getCurrentFrame().addAllItems(trackWidget.getItems());
+		DisplayController.getCurrentFrame().addAllItems(trackWidget.getItems());
 		
 		return trackWidget.getSource(); // Don't allow for other importers to deal with this file
Index: /trunk/src/org/apollo/items/EmulatedTextItem.java
===================================================================
--- /trunk/src/org/apollo/items/EmulatedTextItem.java	(revision 1101)
+++ /trunk/src/org/apollo/items/EmulatedTextItem.java	(revision 1102)
@@ -1,16 +1,4 @@
 package org.apollo.items;
 
-import java.awt.AWTException;
-import java.awt.Color;
-import java.awt.Component;
-import java.awt.Cursor;
-import java.awt.Font;
-import java.awt.Graphics;
-import java.awt.Graphics2D;
-import java.awt.IllegalComponentStateException;
-import java.awt.Point;
-import java.awt.Rectangle;
-import java.awt.Robot;
-import java.awt.Shape;
 import java.awt.event.KeyEvent;
 import java.awt.event.KeyListener;
@@ -18,18 +6,19 @@
 import java.awt.event.MouseListener;
 import java.awt.event.MouseMotionListener;
-import java.awt.geom.Area;
-import java.awt.geom.Point2D;
 import java.util.LinkedList;
 import java.util.List;
 
-import javax.swing.JComponent;
-import javax.swing.SwingUtilities;
-
-import org.expeditee.gui.Browser;
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.core.Clip;
+import org.expeditee.core.Colour;
+import org.expeditee.core.Cursor;
+import org.expeditee.core.Font;
+import org.expeditee.core.Point;
+import org.expeditee.core.EnforcedClipStack.EnforcedClipKey;
+import org.expeditee.core.bounds.AxisAlignedBoxBounds;
+import org.expeditee.gio.EcosystemManager;
+import org.expeditee.gio.GraphicsManager;
+import org.expeditee.gio.gesture.StandardGestureActions;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.gui.Frame;
-import org.expeditee.gui.FrameGraphics;
-import org.expeditee.gui.FrameMouseActions;
-import org.expeditee.gui.MouseEventRouter;
 import org.expeditee.gui.Popup;
 import org.expeditee.gui.PopupManager;
@@ -38,5 +27,4 @@
 
 /**
- * 
  * Its a terrible hack - but it will do.
  * 
@@ -44,26 +32,12 @@
  *
  */
-public class EmulatedTextItem {
-
-	private static final long serialVersionUID = 1L;
-	
-	private static Robot robot;
-
+public class EmulatedTextItem
+{
 	private List<TextChangeListener> textChangeListeners = new LinkedList<TextChangeListener>();
 	
 	private RestrictedTextItem emulatedSource;
 	private LabelEditPopup popup = null;
-	private JComponent parentComponant = null;
-	private Point masterOffset;
-	
-	private static final Font DEFAULT_FONT = new Font("Serif-Plain", Font.PLAIN, 12);
-	
-	static {
-		try {
-			robot = new Robot();
-		} catch (AWTException e) {
-			e.printStackTrace();
-		}
-	}
+	
+	private static final Font DEFAULT_FONT = new Font("Serif-Plain", Font.Style.PLAIN, 12);
 	
 	/**
@@ -77,25 +51,37 @@
 	 * 		Must not be null.
 	 */
-	public EmulatedTextItem(JComponent parent, Point offset) {
-		assert(parent != null);
-		assert(offset != null);
-		
-		parentComponant = parent;
-		masterOffset = offset;
+	public EmulatedTextItem(String text, Point position)
+	{
+		assert(position != null);
+		
 		emulatedSource = new RestrictedTextItem();
-		emulatedSource.setPosition(parent.getX() + offset.x, parent.getY() + offset.y);
+		emulatedSource.setPosition(position);
 		emulatedSource.setFont(DEFAULT_FONT);
-
-	}
-	
-	
-	public void setFontStyle(int style) {
-		emulatedSource.setFont(emulatedSource.getFont().deriveFont(style));
-	}
-	
-	public void setFontSize(float size) {
+		emulatedSource.setText(text);
+		
+		popup = new LabelEditPopup();
+		PopupManager.getInstance().add(popup);
+	}
+	
+	@Override
+	public void finalize()
+	{
+		PopupManager.getInstance().remove(popup);
+	}
+	
+	public void setFontStyle(Font.Style style)
+	{
+		emulatedSource.setFont(emulatedSource.getFont().clone().setStyle(style));
+	}
+	
+	public void setFontSize(float size)
+	{
 		emulatedSource.setSize(size);
 	}
 	
+	public void setPosition(Point position)
+	{
+		emulatedSource.setPosition(position);
+	}
 	
 	/**
@@ -107,21 +93,14 @@
 	 * 		True if the event is over the emulated item.
 	 */
-	private boolean isOnEmulatedText(MouseEvent swingME) {
-		if (swingME == null) return false;
-		Point p = convertToExpediteeSpace(swingME.getLocationOnScreen());
+	private boolean isOnEmulatedText()
+	{
+		Point p = EcosystemManager.getInputManager().getCursorPosition();
+		
 		return isOnEmulatedText(p.x, p.y);
 	}
 	
-	private boolean isOnEmulatedText(int expX, int expY) {
+	private boolean isOnEmulatedText(int expX, int expY)
+	{
 		return emulatedSource.contains(expX, expY);
-	}
-	
-	private Point convertToExpediteeSpace(Point screenPos) {
-		assert(screenPos != null);
-		
-		Point expPoint = new Point(0, 0);
-		SwingUtilities.convertPointToScreen(expPoint, Browser._theBrowser.getContentPane());
-		
-		return new Point(screenPos.x - expPoint.x, screenPos.y - expPoint.y);
 	}
 	
@@ -132,88 +111,48 @@
 	 * @param parent
 	 */
-	public boolean onMouseMoved(MouseEvent e, Component parent) {
-
-		if (isOnEmulatedText(e)) {
+	public boolean onMouseMoved(MouseEvent e)
+	{
+		if (isOnEmulatedText()) {
 			
 			if (emulatedSource.getHighlightMode() != HighlightMode.Normal) {
 				emulatedSource.setHighlightMode(HighlightMode.Normal);
+				emulatedSource.setHighlightColorToDefault();
 				repaint();
 			}
 			
-			if (parent != popup && 
-					(emulatedSource.getBoundsWidth() + masterOffset.x) > (parent.getWidth() - 10)) { // have some give to transition over widget edge
-				if (popup == null) {
-					popup = new LabelEditPopup();
-				}
-				
-				int x = (emulatedSource.getPolygon() == null) ? parent.getX() + masterOffset.x : emulatedSource.getPolygon().getBounds().x;
-				int y = (emulatedSource.getPolygon() == null) ? parent.getY() + masterOffset.y : emulatedSource.getPolygon().getBounds().y;
-				x -= 2;
-				y -= 2;
-
-				if (!PopupManager.getInstance().isShowing(popup)) {
-					PopupManager.getInstance().showPopup(
-							popup, 
-							new Point(x, y), 
-							popup);  
-				}
-				
-			}
-			
 			return true;
-			
 		} else {
-			
 			lostFocus();
-
 		}
 		
 		return false;
-		
-	}
-	
-	/**
-	 * 
-	 * @param e
-	 * 
-	 * @param parent
-	 */
-	public boolean onKeyPressed(KeyEvent e, Component parent) {
-
-		MouseEvent currentME = MouseEventRouter.getCurrentMouseEvent();
-		
-		if (currentME == null) return false;
-		
-		Point p = convertToExpediteeSpace(currentME.getLocationOnScreen());
+	}
+	
+	public boolean onKeyTyped(KeyEvent e)
+	{
+		Point p = EcosystemManager.getInputManager().getCursorPosition();
 
 		// If so and the event really comes from its parent ...
-		if (currentME.getComponent() == parent && 
-				(isOnEmulatedText(p.x, p.y))) {
-			
-			int yOffset = (parent == popup) ? -6 : -6;
-			
-			Browser._theBrowser.setCursor(Cursor.getPredefinedCursor(Cursor.TEXT_CURSOR));
+		if (isOnEmulatedText(p.x, p.y)) {
+			
+			int yOffset = -6;
+			
+			EcosystemManager.getGraphicsManager().setCursor(new Cursor(Cursor.CursorType.TEXT));
 
 			// If a alphanumeric text entry...
-			if (!e.isActionKey() && 
-					(Character.isLetterOrDigit(e.getKeyChar()) || 
-							(e.getKeyChar() == KeyEvent.VK_BACK_SPACE && !emulatedSource.isEmpty()) ||
-							(e.getKeyChar() == KeyEvent.VK_DELETE && !emulatedSource.isEmpty()) ||
-							e.getKeyChar() == KeyEvent.VK_SPACE ||
-							e.getKeyChar() == KeyEvent.VK_UNDERSCORE) ||
-							e.getKeyChar() == KeyEvent.VK_AMPERSAND ||
-							e.getKeyChar() == KeyEvent.VK_OPEN_BRACKET ||
-							e.getKeyChar() == KeyEvent.VK_CLOSE_BRACKET ||
-							e.getKeyChar() == KeyEvent.VK_MINUS) {
-
-
-				Rectangle[] oldArea = emulatedSource.getDrawingArea();
-				int oldWidth = emulatedSource.getBoundsWidth();
-				
+			if (!e.isActionKey() &&
+					Character.isLetterOrDigit(e.getKeyChar()) || 
+					(e.getKeyChar() == Text.BACKSPACE_CHARACTER && !emulatedSource.isEmpty()) ||
+					(e.getKeyChar() == Text.DELETE_CHARACTER && !emulatedSource.isEmpty()) ||
+					e.getKeyChar() == ' ' ||
+					e.getKeyChar() == '_' ||
+					e.getKeyChar() == '&' ||
+					e.getKeyChar() == '(' ||
+					e.getKeyChar() == ')' ||
+					e.getKeyChar() == '-'
+				)
+			{
 				// Insert the text according to the current mouse position
-				Point2D.Float newMouse = emulatedSource.insertChar(
-						e.getKeyChar(), 
-						p.x, 
-						p.y);
+				Point newMouse = emulatedSource.insertChar(e.getKeyChar(), p.x, p.y);
 				
 				List<String> lines = emulatedSource.getTextList();
@@ -225,33 +164,8 @@
 				fireTextChanged();
 
-				// Move "cursured mouse"
+				// Move "cursored mouse"
 				if (newMouse != null) {
-					Point bloc = Browser._theBrowser.getContentPane().getLocationOnScreen();
-					robot.mouseMove(bloc.x + (int)newMouse.x, bloc.y + (int)newMouse.y + yOffset);
+					EcosystemManager.getInputManager().setCursorPosition(new Point((int) newMouse.x, (int) newMouse.y + yOffset));
 				}
-				
-				// Invalidate emulated item if not in popup (popup will naturally handle invalidation)
-				if (parent != popup) {
-
-					if (oldWidth > emulatedSource.getBoundsWidth()) {
-						for (Rectangle r : oldArea) 
-							FrameGraphics.invalidateArea(r);
-					}
-					
-					repaint();
-
-				}
-				
-			} else if (e.getKeyCode() == KeyEvent.VK_LEFT || e.getKeyCode() == KeyEvent.VK_RIGHT) {
-				
-				Point2D.Float newMouse = emulatedSource.moveCursor(
-						(e.getKeyCode() == KeyEvent.VK_LEFT) ? Text.LEFT : Text.RIGHT, 
-						(float)p.getX(), (float)p.getY(), false, false);
-				
-				if (newMouse != null) {
-					Point bloc = Browser._theBrowser.getContentPane().getLocationOnScreen();
-					robot.mouseMove(bloc.x + (int)newMouse.x, bloc.y + (int)newMouse.y + yOffset);
-				}
-
 			}
 			
@@ -274,17 +188,58 @@
 	 * @param parent
 	 */
-	public boolean onKeyReleased(KeyEvent e, Component parent) {
-		return isOnEmulatedText(MouseEventRouter.getCurrentMouseEvent());
-		
-	}
-	
-	
-	public boolean onMouseReleased(MouseEvent e) {
-		
-		Point p = convertToExpediteeSpace(e.getLocationOnScreen());
+	public boolean onKeyPressed(KeyEvent e)
+	{
+		Point p = EcosystemManager.getInputManager().getCursorPosition();
 
 		// If so and the event really comes from its parent ...
 		if (isOnEmulatedText(p.x, p.y)) {
 			
+			int yOffset = -6;
+			
+			EcosystemManager.getGraphicsManager().setCursor(new Cursor(Cursor.CursorType.TEXT));
+
+			// If a alphanumeric text entry...
+			if (e.getKeyCode() == KeyEvent.VK_LEFT || e.getKeyCode() == KeyEvent.VK_RIGHT) {
+				
+				Point newMouse = emulatedSource.moveCursor(
+						(e.getKeyCode() == KeyEvent.VK_LEFT) ? Text.LEFT : Text.RIGHT, 
+						(float)p.getX(), (float)p.getY(), false, false);
+				
+				if (newMouse != null) {
+					EcosystemManager.getInputManager().setCursorPosition(new Point((int) newMouse.x, (int) newMouse.y + yOffset));
+				}
+
+			}
+			
+			if (emulatedSource.hasSelection()) {
+				emulatedSource.clearSelection();
+				repaint();
+			}
+			
+			return true;
+			
+		}
+		
+		return false;
+	}
+	
+	/**
+	 * 
+	 * @param e
+	 * 
+	 * @param parent
+	 */
+	public boolean onKeyReleased(KeyEvent e)
+	{
+		return isOnEmulatedText();
+	}
+	
+	
+	public boolean onMouseReleased(MouseEvent e)
+	{
+		Point p = EcosystemManager.getInputManager().getCursorPosition();
+
+		// If so and the event really comes from its parent ...
+		if (isOnEmulatedText(p.x, p.y)) {
 			
 			String toMoveIntoFreespace = null;
@@ -292,8 +247,5 @@
 			if (e.getButton() == MouseEvent.BUTTON1) {
 				// LINK
-			} else if (e.getButton() == MouseEvent.BUTTON2 && 
-					emulatedSource.hasSelection() && 
-					!emulatedSource.isEmpty() &&
-					emulatedSource.selectionMouseButton == MouseEvent.BUTTON2) {
+			} else if (e.getButton() == MouseEvent.BUTTON2 && emulatedSource.hasSelection() && !emulatedSource.isEmpty()) {
 	
 				invalidate();
@@ -301,8 +253,5 @@
 				toMoveIntoFreespace = emulatedSource.cutSelectedText();
 				
-			} else if (e.getButton() == MouseEvent.BUTTON3 && 
-					emulatedSource.hasSelection() && 
-					!emulatedSource.isEmpty() &&
-					emulatedSource.selectionMouseButton == MouseEvent.BUTTON3) {
+			} else if (e.getButton() == MouseEvent.BUTTON3 && emulatedSource.hasSelection() && !emulatedSource.isEmpty()) {
 				toMoveIntoFreespace = emulatedSource.copySelectedText();
 				
@@ -315,10 +264,10 @@
 			if (toMoveIntoFreespace != null) {
 				
-				Frame target = DisplayIO.getCurrentFrame();
+				Frame target = DisplayController.getCurrentFrame();
 				if (target != null) {
 					Text selectionCopy = new Text(target.getNextItemID(), toMoveIntoFreespace);
 					selectionCopy.setPosition(p.x, p.y);
 					selectionCopy.setSize(emulatedSource.getSize());
-					FrameMouseActions.pickup(selectionCopy);
+					StandardGestureActions.pickup(selectionCopy);
 					lostFocus();
 				}
@@ -336,7 +285,7 @@
 	}
 	
-	public boolean onMousePressed(MouseEvent e) {
-
-		Point p = convertToExpediteeSpace(e.getLocationOnScreen());
+	public boolean onMousePressed(MouseEvent e)
+	{
+		Point p = EcosystemManager.getInputManager().getCursorPosition();
 
 		// If so and the event really comes from its parent ...
@@ -354,15 +303,17 @@
 	}
 	
-	public boolean onMouseClicked(MouseEvent e) {
-		return isOnEmulatedText(e);
-	}
-	public boolean onMouseDragged(MouseEvent e) {
-
-		Point p = convertToExpediteeSpace(e.getLocationOnScreen());
+	public boolean onMouseClicked(MouseEvent e)
+	{
+		return isOnEmulatedText();
+	}
+	
+	public boolean onMouseDragged(MouseEvent e)
+	{
+		Point p = EcosystemManager.getInputManager().getCursorPosition();
 
 		// If so and the event really comes from its parent ...
 		if (isOnEmulatedText(p.x, p.y)) {
 
-			Browser._theBrowser.setCursor(Cursor.getPredefinedCursor(Cursor.TEXT_CURSOR));
+			EcosystemManager.getGraphicsManager().setCursor(new Cursor(Cursor.CursorType.TEXT));
 			
 			emulatedSource.setSelectionEnd(p.x, p.y);
@@ -375,12 +326,20 @@
 	}
 	
-	public void addTextChangeListener(TextChangeListener listener) {
+	public void addTextChangeListener(TextChangeListener listener)
+	{
 		assert(listener != null);
-		if (!textChangeListeners.contains(listener))
-			textChangeListeners.add(listener);
-	}
-	
-	public void lostFocus() {
-		Browser._theBrowser.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
+		if (!textChangeListeners.contains(listener)) textChangeListeners.add(listener);
+	}
+	
+	public void gainFocus()
+	{
+		if (popup != null && !PopupManager.getInstance().isShowing(popup)) {
+			popup.show();
+		}
+	}
+	
+	public void lostFocus()
+	{
+		EcosystemManager.getGraphicsManager().setCursor(new Cursor(Cursor.CursorType.DEFAULT));
 		
 		boolean dirty = false;
@@ -392,10 +351,10 @@
 		if (emulatedSource.getHighlightMode() != HighlightMode.None) {
 			emulatedSource.setHighlightMode(HighlightMode.None);
+			emulatedSource.setHighlightColorToDefault();
 			dirty = true;
 		}
 
-		if (popup != null &&
-				PopupManager.getInstance().isShowing(popup)) {
-			PopupManager.getInstance().hidePopup(popup);
+		if (popup != null && PopupManager.getInstance().isShowing(popup)) {
+			popup.hide();
 		}
 		
@@ -410,5 +369,6 @@
 	 * 		Null is allowed
 	 */
-	public void setText(String text) {
+	public void setText(String text)
+	{
 		if (text == null) text = "";
 		
@@ -424,110 +384,46 @@
 	}
 	
-	public String getText() {
+	public String getText()
+	{
 		return emulatedSource.getText();
 	}
 	
-	private void fireTextChanged() {
-		
-		for (TextChangeListener listener : textChangeListeners)
+	private void fireTextChanged()
+	{
+		for (TextChangeListener listener : textChangeListeners) {
 			listener.onTextChanged(this, this.emulatedSource.getText());
-		
-	}
-
-	public void setBackgroundColor(Color c) {
+		}
+	}
+
+	public void setBackgroundColor(Colour c)
+	{
 		emulatedSource.setBackgroundColor(c);
 	}
 	
-	private void repaint() {
-
+	private void repaint()
+	{
 		if (popup != null && PopupManager.getInstance().isShowing(popup)) {
 			popup.invalidateAppearance();
-			FrameGraphics.refresh(true);
+			DisplayController.requestRefresh(true);
 		} else {
 			invalidate();
-			FrameGraphics.refresh(true);
-		}
-	}
-	
-	private void invalidate() {
-		for (Rectangle r : emulatedSource.getDrawingArea()) 
-			FrameGraphics.invalidateArea(r);
-	}
-
-	public void paint(Graphics g) {
-		
-		if ((popup != null && PopupManager.getInstance().isShowing(popup)) ||
-				!parentComponant.isShowing())
-			return;
-		
-		Point pos;
-		try {
-		pos = this.convertToExpediteeSpace(parentComponant.getLocationOnScreen());
-		} catch (Exception e) {
-			e.printStackTrace();
-			return;
-		}
-
-		paint(	g, 
-				pos.x + masterOffset.x, 
-				pos.y + masterOffset.y, 
-				parentComponant.getWidth() - masterOffset.x);
-	}
-	
-	private void paint(Graphics g, int parentX, int parentY, int maxWidth) {
-
-		if (Browser._theBrowser == null) return;
-		
-		/*int xoffset = (emulatedSource.getLink() == null) ? 6 : 18;
-		int yoffset = emulatedSource.getBoundsHeight() - 3;
-		parentX += xoffset;
-		parentY += yoffset;*/
-		
-		// Set the emulated position according to the parent position - the parent position
-		// can be from the popup or the actual parent componant
-		if (emulatedSource.getX() != parentX || emulatedSource.getY() != parentY)
-			emulatedSource.setPosition(parentX, parentY);
-
-		Shape saveClip = g.getClip();
-		
-		if (maxWidth > 0) {
-			
-			Area clip = FrameGraphics.getCurrentClip();
-
-			Area tmpClip = (clip != null) ? clip : 
-				new Area(new Rectangle(0, 0, 
-						Browser._theBrowser.getContentPane().getWidth(), 
-						Browser._theBrowser.getContentPane().getHeight()));
-			
-		/*	tmpClip.intersect(new Area(new Rectangle(0, 0,
-					parentX + maxWidth - xoffset, Browser._theBrowser.getContentPane().getHeight()
-			)));*/
-			
-			tmpClip.intersect(new Area(new Rectangle(0, 0,
-					parentX + maxWidth, Browser._theBrowser.getContentPane().getHeight()
-			)));
-	
-			// No intersection
-			if (!tmpClip.isEmpty()) 
-				g.setClip(tmpClip);
-		
-		}
-		
-		emulatedSource.paint((Graphics2D)g);
-		
-		// Restore
-		if (maxWidth > 0) {
-			g.setClip(saveClip);
-		}
-		
-		// Restore emulated position for consuming mouse movements
-		try {
-		Point pos = this.convertToExpediteeSpace(parentComponant.getLocationOnScreen());
-		emulatedSource.setPosition(
-				pos.x + masterOffset.x, 
-				pos.y + masterOffset.y);
-		} catch (IllegalComponentStateException ex) { // Cannot fix this .. this whole class needs revising
-			ex.printStackTrace();
-		}
+			DisplayController.requestRefresh(true);
+		}
+	}
+	
+	private void invalidate()
+	{
+		DisplayController.invalidateArea(emulatedSource.getDrawingArea());
+	}
+	
+	public void paint()
+	{
+		GraphicsManager gm = EcosystemManager.getGraphicsManager();
+
+		EnforcedClipKey key = gm.pushClip(new Clip(emulatedSource.getDrawingArea()));
+		
+		emulatedSource.paint();
+
+		gm.popClip(key);
 	}
 	
@@ -537,114 +433,133 @@
 	}
 	
-	private class LabelEditPopup extends Popup implements KeyListener, MouseListener, MouseMotionListener {
-		
-		private static final long serialVersionUID = 1L;
-		
-		LabelEditPopup() {
-			super.setAudoHide(true);
+	private class LabelEditPopup extends Popup implements KeyListener, MouseListener, MouseMotionListener
+	{
+		LabelEditPopup()
+		{
+			super(null); // No animation (instant show/hide)
 			super.setConsumeBackClick(false);
 			super.setBorderThickness(0);
-			
-			updateSize();
-			
-			addKeyListener(this);
-			addMouseListener(this);
-			addMouseMotionListener(this);
-		}
-		
-		public void updateSize() {
-			setSize(emulatedSource.getBoundsWidth() + 4, emulatedSource.getBoundsHeight() + 4);
-		}
-	
-
-		public void keyPressed(KeyEvent e) {
-			onKeyPressed(e, LabelEditPopup.this);
-			updateSize();
-		}
-
-		public void keyReleased(KeyEvent e) {
-		}
-		
-
-		public void keyTyped(KeyEvent e) {
-		}
-		
-		
-		public void mouseClicked(MouseEvent e) {
-		}
-
-		public void mouseEntered(MouseEvent e) {
-		}
-
-		public void mouseExited(MouseEvent e) {
-		}
-
-		public void mousePressed(MouseEvent e) {
-			onMousePressed(e);
-		}
-
-		public void mouseReleased(MouseEvent e) {
-			onMouseReleased(e);
-			updateSize();
-		}
-		
-
-		public void mouseDragged(MouseEvent e) {
-			onMouseDragged(e);
-		}
-
-		public void mouseMoved(MouseEvent e) {
-
-		}
-
-		@Override
-		public void onHide() {
-			super.onHide();
-		}
-	
-		@Override
-		public void onShow() {
-			super.onShow();
-		}
-		
-		
-
-		@Override
-		public void paint(Graphics g) {
-			
-			EmulatedTextItem.this.paint(g, 7, 16, -1);
-
-		}
-	
-	}
-	
-	private class RestrictedTextItem extends Text {
-		
-		private Color selectionColor = null;
-		private int selectionMouseButton = -1;
-		
-		RestrictedTextItem() {
+		}
+
+		@Override
+		public void onHide()
+		{
+		}
+	
+		@Override
+		public void onShow()
+		{
+		}
+		
+		@Override
+		public void paintInternal()
+		{
+			EmulatedTextItem.this.paint();
+		}
+
+		@Override
+		public AxisAlignedBoxBounds getFullBounds()
+		{
+			return emulatedSource.getDrawingArea();
+		}
+
+		@Override
+		public void mouseDragged(MouseEvent e)
+		{
+			boolean consume = onMouseDragged(e);
+			if (consume) e.consume();
+		}
+
+		@Override
+		public void mouseMoved(MouseEvent e)
+		{
+			boolean consume = onMouseMoved(e);
+			if (consume) e.consume();
+		}
+
+		@Override
+		public void mouseClicked(MouseEvent e)
+		{
+			boolean consume = onMouseClicked(e);
+			if (consume) e.consume();
+		}
+
+		@Override
+		public void mousePressed(MouseEvent e)
+		{
+			boolean consume = onMousePressed(e);
+			if (consume) e.consume();
+		}
+
+		@Override
+		public void mouseReleased(MouseEvent e)
+		{
+			boolean consume = onMouseReleased(e);
+			if (consume) e.consume();
+		}
+
+		@Override
+		public void mouseEntered(MouseEvent e)
+		{
+			// Not required
+		}
+
+		@Override
+		public void mouseExited(MouseEvent e)
+		{
+			// Not required
+		}
+
+		@Override
+		public void keyTyped(KeyEvent e)
+		{
+			boolean consume = onKeyTyped(e);
+			if (consume) e.consume();
+		}
+
+		@Override
+		public void keyPressed(KeyEvent e)
+		{
+			boolean consume = onKeyPressed(e);
+			if (consume) e.consume();
+		}
+
+		@Override
+		public void keyReleased(KeyEvent e)
+		{
+			boolean consume = onKeyReleased(e);
+			if (consume) e.consume();
+		}
+	
+	}
+	
+	private class RestrictedTextItem extends Text
+	{
+		private Colour selectionColor = null;
+		
+		RestrictedTextItem()
+		{
 			super(1);
 		}
 		
-		private void updateSelection(int mouseButton) {
-			selectionColor = super.getSelectionColor(mouseButton);
-			selectionMouseButton = mouseButton;
-		}
-
-		public void setSelectionStart(float mouseX, float mouseY, int mouseButton) {
+		private void updateSelection()
+		{
+			selectionColor = super.getSelectionColour();
+		}
+
+		public void setSelectionStart(float mouseX, float mouseY, int mouseButton)
+		{
 			super.setSelectionStart(mouseX, mouseY);
-			updateSelection(mouseButton);
-		}
-		
-		
-
-		@Override
-		protected Color getSelectionColor(int mouseButton) {
-			
-			if (selectionColor != null)
+			updateSelection();
+		}
+		
+		@Override
+		public Colour getSelectionColour()
+		{
+			if (selectionColor != null) {
 				return selectionColor;
-			
-			else return super.getSelectionColor(mouseButton);
+			} else {
+				return super.getSelectionColour();
+			}
 
 		}
